/* ===================================================================
* Author: Jed Brown <http://jedbrown.net/contact>
* WWW: http://performancing.com/firefox
* ===================================================================*/
//var gTheAnswer = []; //Temp global for debugging
//var gPostObject = [];

/*
Needed for PFF Addon spec
*/
var pffmyspace = {
    //Addon Specific
    name: "MySpace",
    version: "0.2",
    description: "MySpace Blogging Mode for PFF",
    author: "Jed Brown",
    id: "pffmyspace",
    pffver: 1.3,
    
    //MySpace Specific
    isloaded: false,
    xmlhttp: null,          //Our HTTP Request object
    publishingTimer: null,  //Our publishing timer
    lastPostObj: null,      //Our posting Object
    firstToggle: false,     //On first myspace enable
    oldPublishLabel: "",    //The selected blog's publish label
    oldPublishURL: "",      //The selected blog's "View Blog' url
    modOn: false,           //Is the mode on or off
    builtEmotions: false    //Already build emotions popup
}

/*
On PFF load, we insert the myspace mode toolbar buttom
*/
pffmyspace.onPFFLoad = function () {
    if(!pffmyspace.isloaded){
        pffmyspace.isloaded = true;
        this.insertMyspaceXUL();
    }
}

/*
On tab click, we load the settings
*/
pffmyspace.onThisTabClick = function () {
    this.loadSettings();
}

/*
TODO - load settings for content (no current settings)
*/
pffmyspace.loadSettings = function () {
    //foo
}

/*
Run on first toggle of Sidebar (When myspace toolbar button is clicked)
*/
pffmyspace.onFirstSidebarLoad = function () {
    pffmyspace.firstToggle = true;
    pffmyspace.loadLoginInfo(); //Load username and password if they were saved
     
    var doAutoLogin = true;
    try{
        doAutoLogin = gPerformancingUtil.prefs.getBoolPref("addons.pffmyspace.autologin");
    }catch(e){}
    
    document.getElementById("pffmyspace-autologin").checked = doAutoLogin;
    if(doAutoLogin){
        //pffmyspace.myspaceTryLogin(); //Buggy, didn't seem to work well
        pffmyspace.myspaceLogin();
        //var progresImage = document.getElementById("pffmyspace-login-checking");
        //progresImage.hidden = false;
    }
}

/*
Load the user name (email) and password if they are saved
*/
pffmyspace.loadLoginInfo = function () {    
    //Load Settings
    var savePassword = true;//gPerformancingUtil.prefs.getBoolPref("extra.delicious.savePassword");
    if(savePassword){
        var theUserName = "";
        try{
            theUserName = gPerformancingUtil.prefs.getCharPref("addons.pffmyspace.login");
        }catch(e){}
        
        if(theUserName != "" && theUserName != "null" ){
            document.getElementById('pffmyspace-login-username').value = theUserName;
            document.getElementById('pffmyspace-login-password').value = gPerformancingUtil.goGetPassword(theUserName, "addon-pffmyspace-user"); //goGetPassword is a PFF function
        }
    }
    document.getElementById('performancing-delicios-login-save').checked = savePassword;
}

/*
Toggle Do Auto Login pref from Checkbox
*/
pffmyspace.toggleAutoLogin = function () {
    var doAutoLogin = document.getElementById("pffmyspace-autologin").checked;
    gPerformancingUtil.prefs.setBoolPref("addons.pffmyspace.autologin", doAutoLogin);
}

/* 
Do the myspace re-login.
Buggy, no longer used, didn't seem to work well. Something is different when you login with pff or normal login.
Could be cache or cookie issues, so we should always login.
*/
pffmyspace.myspaceTryLogin = function () {
    var doAutoLogin = document.getElementById("pffmyspace-autologin").checked;
    if(doAutoLogin){
        var referer = "http://www.myspace.com/";
        var msUrl = "http://login.myspace.com/index.cfm?fuseaction=login.process";
        var msMsg = "";
        pffmyspace.myXMLRequestObject(msMsg, msUrl, pffmyspace.onTryLoginResult, referer );
    }
}

/*
Re-login in the event Myspace logges us out
*/
pffmyspace.reLogin = function () {
     var mySpaceSBDeck = document.getElementById("pffmyspace-sidebar-deck");
     mySpaceSBDeck.selectedPanel.setAttribute("collapsed", true);
     mySpaceSBDeck.selectedIndex = 0;
     mySpaceSBDeck.selectedPanel.setAttribute("collapsed", false);
     pffmyspace.myspaceLogin();
}

/*
Do Myspace Login, should set cookies, etc.
*/
pffmyspace.myspaceLogin = function () {
    var userName = document.getElementById("pffmyspace-login-username").value; //
    var passWord = document.getElementById("pffmyspace-login-password").value; //
    if(userName != "" && passWord != "" ){
        //Save the username and password
        var savePassword = true; //Make this a checkbox pref
        if(savePassword){
            var addedUser = gPerformancingUtil.usermanagment.storeLoginDetails(userName, passWord, "addon-pffmyspace-user");
            gPerformancingUtil.prefs.setCharPref("addons.pffmyspace.login", userName);
        }
        //var progresChecking = document.getElementById("pffmyspace-login-checking");
        //progresChecking.hidden = true;
        var progresImage = document.getElementById("pffmyspace-login-loading");
        progresImage.hidden = false;
        userName = encodeURIComponent(userName); //Not sure this is needed, but let's mimic myspace.com as much as possible
        passWord = encodeURIComponent(passWord);
        var msUrl = "http://login.myspace.com/index.cfm?fuseaction=login.process";
        var msMsg = "email=" +userName+ "&password=" +passWord+ "&Remember=Remember&ctl00%24Main%24SplashDisplay%24login%24loginbutton.x=25&ctl00%24Main%24SplashDisplay%24login%24loginbutton.y=10";
        var referer = "http://www.myspace.com/";
        pffmyspace.setPublishTimer(3); //3min for login
        pffmyspace.myXMLRequestObject(msMsg, msUrl, pffmyspace.onLoginResult, referer );
    }
}

/*
Check to see if user is logged in, or if login worked
*/
pffmyspace.isLoggedIn = function (aText, isError) {
    var isLoggedOut = aText.match("fuseaction=Join");
    if(!isError && !isLoggedOut){
        return true;
    }else{
        return false;
    }
}

/*
Bugging, no longer used
*/
pffmyspace.onTryLoginResult = function (aMsg, isError) {
    var isLoggedIn = pffmyspace.isLoggedIn( aMsg, isError );
    //alert("Tried Login\n"+isLoggedIn);
    if(isLoggedIn){
        pffmyspace.onLoggedIn();
    }else{
        var doAutoLogin = document.getElementById("pffmyspace-autologin").checked;
        if(doAutoLogin){
            pffmyspace.myspaceLogin();
        }
    }
}

/*
Login Result feedback
*/
pffmyspace.onLoginResult = function (aMsg, isError) {
    pffmyspace.cancelPublishTimer();
    var isLoggedIn = pffmyspace.isLoggedIn( aMsg, isError );
    
    if(isLoggedIn){
        pffmyspace.onLoggedIn();
        //var theIframe  = document.getElementById("pffmyspace-iframe");
        //theIframe.addEventListener("DOMContentLoaded", callMe, false);
        //theIframe.setAttribute("src","http://blog.myspace.com/index.cfm?fuseaction=blog.create&editor=true");
    }else{
        //alert("Error Logging into MySpace\nUser or password not valid.\nPlease try again.");
        var loginErrorBox = document.getElementById("pffmyspace-login-error");
        var loginLoadBox = document.getElementById("pffmyspace-login-loading");
        //var progresChecking = document.getElementById("pffmyspace-login-checking");
        //progresChecking.hidden = true;
        loginLoadBox.hidden = true;
        loginErrorBox.hidden = false;
    }
}

/*
Should always return true, we always assume it worked so call postEntry
*/
pffmyspace.onPreviewResult = function (aMsg, isError) {
    pffmyspace.cancelPublishTimer();
    //gTheAnswer.push(aMsg);
    var theHash = null;
    if(!isError){
        theHash = aMsg.match(/(?:name\=\"\hash\"\svalue\=\")(........+)(?=\")/);
        if(theHash != null){
            pffmyspace.lastPostObj.hash = theHash[1];
            pffmyspace.postEntry();
        }else{
            alert("Error trying to publish (#102), please try again\nIf you still get this error\nTry re-logging into Myspace first.");
            pffmyspace.onPublishError();
        }
    }else{
        alert("Error (#101) sending preview into MySpace\nPlease re-log into Myspace and try again. ");
    }
}

/*
Result should be published now (no real error feedback) so go tell user
TODO implement Ping, trackback and Delicious bookmarks
*/
pffmyspace.onPublishResult = function (aMsg, isError) {
    pffmyspace.cancelPublishTimer();
    //gTheAnswer.push(aMsg);
    if(!isError){
        var thePublishDeck = document.getElementById('performancing-feedback-deck');
        thePublishDeck.setAttribute('selectedIndex','0'); //Default PFF 'Published' window.
        
        //Parse the result and get the new blogID (Should be top blog entry.. this could be buggy.)
        //var theBlogId = aMsg.match(/(?:\&blogID\=)(\d+)(?=&\Mytoken)/);
        var theBlogUrl = aMsg.match(/(\&friendID\=\d+\&blogID\=\d+)(?=&\Mytoken)/);
        if(theBlogUrl && theBlogUrl[0]){
            var theBlogId = theBlogUrl[0].match(/(?:\&blogID\=)(\d+)/);
            pffmyspace.lastPostObj.blogId = theBlogId[1];
            
            var theURL = "http://blog.myspace.com/index.cfm?fuseaction=blog.view"+ theBlogUrl[0];
            var theTitle = aMsg.match(/(?:\<title\>)(.+)(?=\<\/title\>)/);
            if(theTitle && theTitle[1]){
                theTitle = theTitle[1];
            }else{
                theTitle = "";
            }
            var theSubject = pffmyspace.getSubject(); //pffmyspace.lastPostObj.subject is dirty
            //Do ping (need BlogID and Name
            window.setTimeout("performancingUI.doPing(\""+ theSubject+"\",\""+ theURL+"\")", 1000, true); //(From xmlrpc.js)
            
            //Add post to delicious
            performancingUI.deliciousAddThecnorati(theURL, theSubject, false, false);
            
            //Send Trackbacks
            window.setTimeout("performancingUI.sendTrackBacks('"+theSubject+"','"+theURL+"','"+theTitle+"')", 2000, true);
        }
        pffmyspace.onPublished();
        
    }else{
        alert("Error Publishing into MySpace (#102)\nPlease try again\nIf you still get this error\nTry re-logging into Myspace first.");
        pffmyspace.onPublishError();
    }
    
}

/*
Our Request Object. Takes a post body, url, a call back function and referer to spoof myspace. (might not need spoofing)
*/
pffmyspace.myXMLRequestObject = function(aMsg, aUrl, aFunction, aReferer) {
    //gPostObject.push(aUrl + " AND " + aMsg);
    pffmyspace.xmlhttp = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance(Components.interfaces.nsIXMLHttpRequest);
    pffmyspace.xmlhttp.open('POST', aUrl, true);
    pffmyspace.xmlhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    pffmyspace.xmlhttp.setRequestHeader('Content-Length', aMsg.length );
    pffmyspace.xmlhttp.setRequestHeader('Referer', aReferer );
    
     pffmyspace.xmlhttp.onreadystatechange=function() {
      if (pffmyspace.xmlhttp.readyState==4) {
          if (pffmyspace.xmlhttp.status == 200) {
               aFunction(pffmyspace.xmlhttp.responseText, false);
          }else{
               aFunction(pffmyspace.xmlhttp.statusMessage, true);
          }
      }
     }
     
     pffmyspace.xmlhttp.send(aMsg);
}

/*
Not yet used
Allows user to abort
*/
pffmyspace.abortRequest = function () {
    pffmyspace.xmlhttp.abort();
}

/*
We should be logged in now, so switch to next pane.
*/
pffmyspace.onLoggedIn = function () {
     var progresImage = document.getElementById("pffmyspace-login-loading");
     progresImage.hidden = false;
     
     var mySpaceSBDeck = document.getElementById("pffmyspace-sidebar-deck");
     mySpaceSBDeck.selectedPanel.setAttribute("collapsed", true);
     mySpaceSBDeck.selectedIndex = 1;
     mySpaceSBDeck.selectedPanel.setAttribute("collapsed", false);
     pffmyspace.setCurrentTime(); //Load current day, time, etc.
}

/*
Inserts the Myspace button in the toolbar
*/
pffmyspace.insertMyspaceXUL = function () {
    
    var theSibarButton = document.getElementById("performancing-sidebarbutton");
    var mySpaceItem = document.createElement('toolbarbutton');
    mySpaceItem.setAttribute("id","pff-addon-pffmyspace");
    //mySpaceItem.setAttribute("class","toolbarbutton-1 chromeclass-toolbar-additional");
    mySpaceItem.setAttribute("state","off");
    mySpaceItem.setAttribute("type","checkbox");
    mySpaceItem.setAttribute("oncommand","pffmyspace.toggleMySPaceMode('');");
    mySpaceItem.setAttribute("tooltiptext","Toggle Myspace Mode On/Off");
    var insertedToobarB = theSibarButton.parentNode.insertBefore(mySpaceItem, theSibarButton);
}

/*
Toggles the myspace 'mode' by bringing up the myspace pane.
*/
pffmyspace.toggleMySPaceMode = function (aForceCommand) {
    //toggles the myspace more on and off.
    var mySpaceSBDeck = document.getElementById("performancing-editor-extra-pub-deck");
    var publishImage = document.getElementById("performancing-publish-imagebutton2");
    var publishLabel = document.getElementById("performancing-blogstatus");
    var myspaceButton = document.getElementById("pff-addon-pffmyspace");
    var publishDeck = document.getElementById("performancing-publish-imagebutton");
    var viewThisBlogLabel = document.getElementById("performance-show-this-blog");
    
    if(aForceCommand == "off" || mySpaceSBDeck.selectedIndex == 2){ //Turn Off
        if(mySpaceSBDeck.selectedIndex != 0){
            mySpaceSBDeck.selectedPanel.setAttribute("collapsed", true);
        }
        mySpaceSBDeck.selectedIndex = 0;
        mySpaceSBDeck.selectedPanel.setAttribute("collapsed", false);
        //gPerformancingUtil.postCurrentItem();
        publishImage.setAttribute("addon", "");
        publishLabel.setAttribute("value", pffmyspace.oldPublishLabel);
        viewThisBlogLabel.setAttribute("blogURL", pffmyspace.oldPublishURL);
        myspaceButton.checked = true;
        publishDeck.setAttribute("onclick", "gPerformancingUtil.postCurrentItem();");
        if(aForceCommand == "off"){
            myspaceButton.checked = false;
        }
        pffmyspace.modOn = false;
    }else{// Turn On
        mySpaceSBDeck.selectedIndex = 2;
        mySpaceSBDeck.selectedPanel.setAttribute("collapsed", false);
        if(publishLabel.value != "MySpace" && publishImage.getAttribute("addon") != "myspace" ){
            pffmyspace.oldPublishLabel = publishLabel.value;
            pffmyspace.oldPublishURL   =   viewThisBlogLabel.getAttribute("blogURL");
        }
        publishImage.setAttribute("addon", "myspace");
        publishLabel.setAttribute("value", "MySpace");
        viewThisBlogLabel.setAttribute("blogURL", "http://blog.myspace.com/index.cfm?fuseaction=blog");
        myspaceButton.checked = false;
        publishDeck.setAttribute("onclick", "pffmyspace.publishEntry();");
        pffmyspace.modOn = true;
    }
    
    if(!pffmyspace.firstToggle){
        pffmyspace.onFirstSidebarLoad();
    }
}

/*
Get's the subject of the post
*/
pffmyspace.getSubject = function () {
    return document.getElementById("performancing-editor-subject").value;
}

/*
Get's the Body of the post
Example taken from PFF midas.js
*/
pffmyspace.getBody = function () {
    var theContent = null;
    var tabbox = document.getElementById("performancing-editor-tabbox");
    if(tabbox.selectedIndex == 0 || tabbox.selectedIndex == 2){//Rich or preview
        var winNormal = document.getElementById("performancing-message");
        theContent = winNormal.contentWindow.document.body.innerHTML;
    }else if(tabbox.selectedIndex == 1){ //Source
        theContent = document.getElementById("performancing-message-source").value
    }
    return theContent;
}

/*
Show/Hide the extra options panel (only mood for now)
*/
pffmyspace.toggleMoreOpts = function () {
    var moreOptionsBox = document.getElementById("pffmyspace-more-options");
    var isHidden = moreOptionsBox.hidden
    moreOptionsBox.hidden = !isHidden;
}

/*
Clear all of the posting options (Reset)
*/
pffmyspace.clearPostingOptions = function () {
    pffmyspace.onPublishError();
    
    pffmyspace.setCurrentTime();
    document.getElementById("pffmyspace-MoodOther").value = "";
    document.getElementById("pffmyspace-MoodID").selectedIndex = 0;
    document.getElementById("pffmyspace-BlogViewingPrivacyID").selectedIndex = 0;
    document.getElementById("pffmyspace-BlogCategoryID").selectedIndex = 0;
    document.getElementById("pffmyspace-ProhibitComments").checked = false;
    
}
/*
Set's up the object we use to hold the post information
(Needed in both preview and post).
*/
pffmyspace.setUpPostObject = function () {
    pffmyspace.lastPostObj = new Object();
    
    var hours = document.getElementById("pffmyspace-postHour").value;
    var theTimeMarker = document.getElementById("pffmyspace-postTimeMarker").value;
    var min = document.getElementById("pffmyspace-postMinute").value;
    var month = document.getElementById("pffmyspace-postMonth").value;
    var day = document.getElementById("pffmyspace-postDay").value;
    var year = document.getElementById("pffmyspace-postYear").value;
    
    var category = document.getElementById("pffmyspace-BlogCategoryID").value;
    var comments = document.getElementById("pffmyspace-ProhibitComments").checked;
    if(comments){
        comments = "1";
    }else{
        comments = "0";
    }
    var privacy = document.getElementById("pffmyspace-BlogViewingPrivacyID").value;
    var mood = document.getElementById("pffmyspace-MoodID").value;
    var moodOther = document.getElementById("pffmyspace-MoodOther").value;
    
    pffmyspace.lastPostObj = {
        blogId: "-1",
        subject: pffmyspace.getSubject(),
        body: pffmyspace.getBody(),
        month: month,
        day: day,
        year: year,
        hour: hours,
        min: min,
        timeMarker: theTimeMarker,
        blogCat: category,
        mode: "music",
        moodSet: "7",
        moodId: mood,
        moodOther: moodOther,
        blogPriv: privacy,
        enclosure: "",
        noComments: comments,
        hash: "",
        foo: "",
        foolast: ""
    }
    
    //return pffmyspace.lastPostObj;
}

/*
    Null's freepost once publish is successfull or on error.
    (free up some memory)
*/
pffmyspace.freePostObject = function () {
    pffmyspace.lastPostObj = null;
}

/*
    Go Publish the entry.
*/
pffmyspace.publishEntry = function () {
    if(pffmyspace.modOn){
        if(performancingUI.checkSubjectEmpty()){
            var mySpaceSBDeck = document.getElementById("performancing-editor-extra-pub-deck");
            //alert("mySpaceSBDeck.selectedIndex: " + mySpaceSBDeck.selectedIndex);
            if(mySpaceSBDeck.selectedIndex == 2){
                pffmyspace.previewEntry();
            }else{ //Ask user what to do.
                var doMSPost = confirm("Post this entry to Myspace?\n(Click cancel to toggle off the Myspace mode\n and to return to your selected blog)");
                if( doMSPost ){
                    pffmyspace.previewEntry();
                }else{
                    pffmyspace.toggleMySPaceMode("off");
                }
            }
        }
    }else{ //Just incase our overlay didn't work
        gPerformancingUtil.postCurrentItem();
    }
}

/*
    Sends preview to Myspace (we then get the hash).
*/
pffmyspace.previewEntry = function () {
    
    var mySpaceSBDeck = document.getElementById("performancing-editor-extra-pub-deck");
    mySpaceSBDeck.selectedIndex = 2;
    
    var postedLabel = document.getElementById("pffmyspace-published-label");
    postedLabel.hidden = true;
    var postingImage = document.getElementById("pffmyspace-publishing-img");
    postingImage.hidden = false;
    var postingBox = document.getElementById("pffmyspace-publish-box");
    postingBox.hidden = false;
    
    //Get Data
    pffmyspace.setUpPostObject();
    
    //Let's try to mimic a normal pff post as much as possible: (from blogXML.js)
    if( gPerformancingUtil.prefs.getBoolPref('extra.inserttechnorati') ){ //Should we insert technorati tags?
        var regXP = /class\=\"performancingtags/;
        if( !pffmyspace.checkIfContentMatch(regXP) ){ //TODO Don't do this for pff > 1.3
            performancingUI.insertTechnorati();
        }
    }
    
    if( gPerformancingUtil.prefs.getBoolPref('extra.insertpfftext2') ) {  //Should we insert "powered by performancing".
        var regXP = /\<p\sclass\=\"poweredbyperformancing\"\>/;
        if( !pffmyspace.checkIfContentMatch(regXP) ){ //TODO Don't do this for pff > 1.3
            performancingUI.insertPoweredByPFF();
        }
    }
    
    var theBody = pffmyspace.getBody();
    var theSubject = pffmyspace.getSubject();
    try{
        var textToSubURI = Components.classes["@mozilla.org/intl/texttosuburi;1"].getService(Components.interfaces.nsITextToSubURI); 
        pffmyspace.lastPostObj.body = textToSubURI.ConvertAndEscape("UTF-8", theBody);       //Dirty, use getBody for clean version
        pffmyspace.lastPostObj.subject = textToSubURI.ConvertAndEscape("UTF-8", theSubject); //Dirty, use getSubject for clean version
    }catch(e){
        alert("Error converting text (error #201):\n" + e);
    }
    
    var referer = "http://blog.myspace.com/index.cfm?fuseaction=blog.previewBlog";
    
    var msUrl = "http://blog.myspace.com/index.cfm?fuseaction=blog.previewBlog";
    
    var msMsg = null;
    try{
        msMsg = "blogID="+pffmyspace.lastPostObj.blogId+"&postMonth="+pffmyspace.lastPostObj.month+"&postDay="+pffmyspace.lastPostObj.day+"&postYear="+pffmyspace.lastPostObj.year+"&postHour="+pffmyspace.lastPostObj.hour+"&postMinute="+pffmyspace.lastPostObj.min+"&postTimeMarker="+pffmyspace.lastPostObj.timeMarker+"&subject="+pffmyspace.lastPostObj.subject+"&BlogCategoryID="+pffmyspace.lastPostObj.blogCat+"&editor=true&body="+pffmyspace.lastPostObj.body+"&CurrentlyASIN=&CurrentlyProductName=&CurrentlyProductBy=&CurrentlyImageURL=&CurrentlyProductURL=&CurrentlyProductReleaseDate=&CurrentlyProductType=&Mode="+pffmyspace.lastPostObj.mode+"&MoodSetID="+pffmyspace.lastPostObj.moodSet+"&MoodID="+pffmyspace.lastPostObj.moodId+"&MoodOther="+pffmyspace.lastPostObj.moodOther+"&BlogViewingPrivacyID="+pffmyspace.lastPostObj.blogPriv+"&Enclosure="+pffmyspace.lastPostObj.enclosure;
    }catch(e){
        alert("Posting to Myspace Error (#202):\n" + e);
    }
    if(msMsg != null){
        pffmyspace.setPublishTimer(2); //2 min for Preview
        pffmyspace.myXMLRequestObject(msMsg, msUrl, pffmyspace.onPreviewResult, referer );
    }
    //convert data
}

/*
Sends entry for publish
(must be run after preview is sent and hash is found)
*/
pffmyspace.postEntry = function () {
    
    //Get Data
    
    var referer = "http://blog.myspace.com/index.cfm?fuseaction=blog.previewBlog";
    
    var theDate = new Date()
    var msUrl = "http://blog.myspace.com/index.cfm?fuseaction=blog.processCreate";
    var msMsg = null;
    try{
        msMsg = "BlogID="+pffmyspace.lastPostObj.blogId+"&PostMonth="+pffmyspace.lastPostObj.month+"&PostDay="+pffmyspace.lastPostObj.day+"&PostYear="+pffmyspace.lastPostObj.year+"&PostHour="+pffmyspace.lastPostObj.hour+"&PostMinute="+pffmyspace.lastPostObj.min+"&PostTimeMarker="+pffmyspace.lastPostObj.timeMarker+"&Subject="+pffmyspace.lastPostObj.subject+"&Body="+pffmyspace.lastPostObj.body+"&CurrentlyASIN=&CurrentlyProductName=&CurrentlyProductBy=&CurrentlyImageURL=&CurrentlyProductURL=&CurrentlyProductReleaseDate=&CurrentlyProductType=&MoodID="+pffmyspace.lastPostObj.moodId+"&MoodOther="+pffmyspace.lastPostObj.moodOther+"&BlogViewingPrivacyID="+pffmyspace.lastPostObj.blogPriv+"&ProhibitComments="+pffmyspace.lastPostObj.noComments+"&Editor=true&MoodSetID="+pffmyspace.lastPostObj.moodSet+"&isPreviewed=true&BlogCategoryID="+pffmyspace.lastPostObj.blogCat+"&hash="+encodeURIComponent(pffmyspace.lastPostObj.hash)+"&Enclosure="+pffmyspace.lastPostObj.enclosure;
    }catch(e){
        alert("Posting to Myspace Error (#203):\n" + e);
    }
    if(msMsg != null){
        pffmyspace.setPublishTimer(3); //3 min for publish
        pffmyspace.myXMLRequestObject(msMsg, msUrl, pffmyspace.onPublishResult, referer );
    }
    //convert data
}

/*
An error occured, do cleanup
*/
pffmyspace.onPublishError = function () {
    var postingImage = document.getElementById("pffmyspace-publishing-img");
    var postedLabel = document.getElementById("pffmyspace-published-label");
    var postingBox = document.getElementById("pffmyspace-publish-box");
    
    postingImage.hidden = true;
    postedLabel.hidden = true;
    postingBox.hidden = true;
    
    pffmyspace.freePostObject();
}

/*
Publish was succesfull, set UI
*/
pffmyspace.onPublished = function () {
    //foo
    //alert("Here we would publish the data!");
    var postingImage = document.getElementById("pffmyspace-publishing-img");
    var postedLabel = document.getElementById("pffmyspace-published-label");
    var postingBox = document.getElementById("pffmyspace-publish-box");
    
    postingImage.hidden = true;
    postedLabel.hidden = false;
    postingBox.hidden = true;
    
    pffmyspace.freePostObject();
}

/*
Set the current time for the myspace form entries
*/
pffmyspace.setCurrentTime = function () {
    var date = new Date();
    var theHours = date.getHours();
    var theTimeMarker = "AM";
    var theTimeMarkerInd = "0";
    if(theHours > 12 && theHours != 0){
        theHours = (theHours - 12);
        theTimeMarker = "PM";
        theTimeMarkerInd = "1";
    }else if(theHours == 0){
        theHours = 12;
        theTimeMarker = "AM";
    }else if(theHours == 12){
        theHours = 12;
        theTimeMarker = "PM";
        var theTimeMarkerInd = "1";
    }
    var month = date.getMonth() + 1;
    var day = date.getDate();
    var year = date.getFullYear();
    var hours = theHours;
    var min = date.getMinutes()
    
    //Set the Elements
    document.getElementById("pffmyspace-postHour").selectedIndex = hours - 1;
    document.getElementById("pffmyspace-postTimeMarker").selectedIndex = theTimeMarkerInd;
    document.getElementById("pffmyspace-postMinute").selectedIndex = min;
    
    document.getElementById("pffmyspace-postMonth").selectedIndex = month - 1;
    document.getElementById("pffmyspace-postDay").selectedIndex = day - 1;
    document.getElementById("pffmyspace-postYear").value = year;
}

/*
    Tell if a pattern exists in the content
    This function will be in PFF for version 1.4
    (called "performancingUI.checkIfContentMatch" )
*/
pffmyspace.checkIfContentMatch = function(theRegExp) {
    var tabbox = document.getElementById("performancing-editor-tabbox");
    var theContent = "";
    //var theTitle = myIframeWindow.getElementById("performancing-editor-subject").value;
    if(tabbox.selectedIndex == 0 || tabbox.selectedIndex == 2){//Rich or preview
        var winNormal = document.getElementById("performancing-message");
        theContent = winNormal.contentWindow.document.body.innerHTML;
    }else if(tabbox.selectedIndex == 1){ //Source
        var theSourceBox = document.getElementById("performancing-message-source");
        theContent = theSourceBox.value;
    }else{
        //alert('PerFormancing Error: Could not find Note content, please contact the author');
        theContent = null;
    }
    if(theContent != null){
        if(theRegExp.test(theContent)){
            return true;
        }
    }
    return false;
}

//Not Used
pffmyspace.onIframeLoad = function () {
    alert("Loaded");
}

/*
    Set a 4min timout incase myspace never responds.
*/
pffmyspace.setPublishTimer = function (theMin) {
    var theMins = (60000 * theMin); //Gives us the minites in ms
    pffmyspace.publishingTimer = window.setTimeout('pffmyspace.onPublishTimeOut()', theMins);
}

/*
    Cancel the timeout, called when we beat the timeout
*/
pffmyspace.cancelPublishTimer = function () {
    window.clearTimeout(pffmyspace.publishingTimer);
}

/*
    Action if we hit the timout
*/
pffmyspace.onPublishTimeOut = function () {
    pffmyspace.abortRequest();
    pffmyspace.onPublishError();
    alert("The Myspace server has times out\nPlease check your blog to see if it posted\nIf not please try again.");
}

//Not Used
pffmyspace.fooBar = function () {
    //foo
}

/*
    This should populate the Myspace Emotion Icons
    It should only run once.
*/
pffmyspace.populateSmileys = function () {
    if(!pffmyspace.builtEmotions){
        var thePopup = document.getElementById("pffmyspace-emotions");
        
        var smileyImagePath = "http://x.myspace.com/images/blog/smileys/";
        var smileyImg = ["amused.gif~amused", "angry.gif~angry", "annoyed.gif~annoyed", "anxious.gif~anxious", "apathetic.gif~apathetic", "artistic.gif~artistic", "awake.gif~awake", "bitter.gif~bitter", "blah.gif~blah", "blank.gif~blank", "blush.gif~blush", "bored.gif~bored", "bouncey.gif~bouncey", "bummed.gif~bummed", "busy.gif~busy", "calm.gif~calm", "censored.gif~censored", "cheerful.gif~cheerful", "chipper.gif~chipper", "clueless.gif~clueless", "cold.gif~cold", "complacent.gif~complacent", "contemplative.gif~contemplative", "content.gif~content", "cool.gif~cool", "cranky.gif~cranky", "crappy.gif~crappy", "crazy.gif~crazy", "creative.gif~creative", "crushed.gif~crushed", "curious.gif~curious", "cynical.gif~cynical", "depressed.gif~depressed", "determined.gif~determined", "devious.gif~devious", "dirty.gif~dirty", "disappointed.gif~disappointed", "distressed.gif~distressed", "ditzy.gif~ditzy", "dorky.gif~dorky", "drunk.gif~drunk", "ecstatic.gif~ecstatic", "embarrassed.gif~embarrassed", "energetic.gif~energetic", "enraged.gif~enraged", "enthralled.gif~enthralled", "envious.gif~envious", "exanimate.gif~exanimate", "excited.gif~excited", "exhausted.gif~exhausted", "frustrated.gif~frustrated", "full.gif~full", "giddy.gif~giddy", "giggly.gif~giggly", "gloomy.gif~gloomy", "groggy.gif~groggy", "grumpy.gif~grumpy", "guilty.gif~guilty", "happy.gif~happy", "heart.gif~heart", "high.gif~high", "hopeful.gif~hopeful", "horny.gif~horny", "hungry.gif~hungry", "hyper.gif~hyper", "indescribable.gif~indescribable", "indifferent.gif~indifferent", "intimidated.gif~intimidated", "irate.gif~irate", "irritated.gif~irritated", "jealous.gif~jealous", "kiss.gif~kiss", "laughing.gif~laughing", "lazy.gif~lazy", "lethargic.gif~lethargic", "listless.gif~listless", "lonely.gif~lonely", "love.gif~love", "melancholy.gif~melancholy", "mellow.gif~mellow", "mischievous.gif~mischievous", "moody.gif~moody", "morose.gif~morose", "naughty.gif~naughty", "nauseated.gif~nauseated", "nerdy.gif~nerdy", "nervous.gif~nervous", "numb.gif~numb", "okay.gif~okay", "optimistic.gif~optimistic", "peaceful.gif~peaceful", "pensive.gif~pensive", "pessimistic.gif~pessimistic", "pissed.gif~pissed", "pleased.gif~pleased", "predatory.gif~predatory", "productive.gif~productive", "quixotic.gif~quixotic", "recumbent.gif~recumbent", "refreshed.gif~refreshed", "rejuvenated.gif~rejuvenated", "relaxed.gif~relaxed", "relieved.gif~relieved", "restless.gif~restless", "rushed.gif~rushed", "sad.gif~sad", "satisfied.gif~satisfied", "shocked.gif~shocked", "shy.gif~shy", "sick.gif~sick", "silly.gif~silly", "sleepy.gif~sleepy", "smooch.gif~smooch", "sore.gif~sore", "stressed.gif~stressed", "stunned.gif~stunned", "surprised.gif~surprised", "sympathetic.gif~sympathetic", "thankful.gif~thankful", "thirsty.gif~thirsty", "thoughtful.gif~thoughtful", "tired.gif~tired", "touched.gif~touched", "uncomfortable.gif~uncomfortable", "unhappy.gif~unhappy", "weird.gif~weird", "whatevah.gif~whatevah", "winky.gif~winky", "working.gif~working", "worried.gif~worried"];
        var cols = 10;
        var i = 0;
        while (i < smileyImg.length) {
            var aHbox = document.createElement('hbox');
            for(var j = 0; j < cols; j++) {
                if (smileyImg[i]) {
                      var anImage = document.createElement('image');
                      anImage.setAttribute('src', smileyImagePath +  smileyImg[i].split("~")[0]);
                      anImage.setAttribute('onclick', "pffmyspace.insertSmileys(this)");
                      anImage.setAttribute('style', "padding: 2px; max-height: 24px; max-width: 24px;");
                      aHbox.appendChild(anImage);
                }
                i++;
            }
            thePopup.appendChild(aHbox);
        }
        pffmyspace.builtEmotions = true;
    }
}

/*
    Insert the clicked Emotion into the Content body
*/
pffmyspace.insertSmileys = function (aObject) {
    var theSrc = aObject.getAttribute('src');
    var midas = document.getElementById("performancing-message");
    try{
        var img = midas.contentWindow.document.createElement("img");
            img.setAttribute("src",theSrc);
            performancingMidas.insertNodeAtSelection(midas.contentWindow, img);
            performancingMidas.placeCaret(midas, img.nextSibling);
    }catch(e){}
}



/******************************************************************************
* Start PFF Specific code
*
* DO NOT MODIFY any function below here, only the "pffmyspace_init" name.
* i.e.  myextension_init
******************************************************************************/
var pffmyspace_init = new pffaddonObject( pffmyspace.name, pffmyspace.version, pffmyspace.description, pffmyspace.author, pffmyspace.id, pffmyspace.pffver );

pffmyspace_init.onPFFLoad = function () {
    pffmyspace.onPFFLoad();
}

pffmyspace_init.onThisTabClick = function () {
    pffmyspace.onThisTabClick();
}

pffmyspace_init.init = function(){
    //Get the pref and set defaults
    var myObserverService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    myObserverService.addObserver(pffmyspace_init, "performancing-addon-pffstart-topic", false);
    myObserverService.addObserver(pffmyspace_init, "performancing-addon-pffenable-topic", false);
    myObserverService.addObserver(pffmyspace_init, "performancing-addon-pffdisable-topic", false);
    myObserverService.addObserver(pffmyspace_init, "performancing-addon-pfftabclick-topic", false);
    myObserverService = null; //Prevent any possible Memory Leaks
}

window.addEventListener('load', pffmyspace_init.init, false);
/********************************************************************/
